/*
	alliance.cpp
	
	(c) Richard Thrippleton, July 2001
	Licensing terms are in the 'LICENSE' file
	If that file is not included with this source then permission is not given to use this source in any way whatsoever.
*/

#include <string.h>
#include <stdio.h>
#include "public.h"
#include "defs.h"
#include "config.h"

const short ALICOUNT=8; //Number of alliances
ali alis[ALICOUNT]; //Alliance database

void initalis()
{
	for(short i=0;i<ALICOUNT;i++)
	{
		alis[i].self=i;
		alis[i].load();
	}
}

void inituniverse()
{
	long sx,sy; //Seed co-ordinates
	for(short i=0;i<ALICOUNT;i++)
	{
		if(alis[i].nam[0]!='\0')
		{
			sx=2*(rnd(LIMIT*2)-LIMIT)/3;
			sy=2*(rnd(LIMIT*2)-LIMIT)/3;
			for(short j=0;j<alis[i].nsys;j++)
			{
				newsystem(sx+rnd(LIMIT/2)-LIMIT/4,sy+rnd(LIMIT/2)-LIMIT/4,i);
			}
		}
	}
}

bool opposes(short a,short b)
{
	if(a==-1||b==-1)
		return false;
	for(short i=0;i<8;i++)
	{
		if(b==alis[a].enem[i])
			return true;
	}
	return false;                                                 
}

void* getali(short indx)
{
	return &alis[indx];

}

short getspawn(short indx)
{
	return alis[indx].sdns[rnd(8)];
}

void ali::load()
{
	char* path; //Path to load equipment data from
	void* strm;  //Filestream to use
	char atsc[33]; //Attribute scratchpad
	
	memtest(path=new char[strlen(DATADIR)+16]);
	sprintf(path,"%s%salliances%s%hd.all",DATADIR,PATHSEP,PATHSEP,self);
	strm=(void*)fopen(path,"r");
	delete(path);
	if(strm!=NULL)
	{
		extractstring(strm,"Name",nam);
		form=extractlong(strm,"Formation");
		for(short i=0;i<8;i++)
		{
			sprintf(atsc,"Enemy%hd",i);
			enem[i]=extractlong(strm,atsc);	
		}
		nsys=extractlong(strm,"Systems");
		pinh=extractlong(strm,"PercentInhabited");
		for(short i=0;i<8;i++)
		{
			sprintf(atsc,"Ship%hd",i);
			sdns[i]=extractlong(strm,atsc);
		}
		fclose((FILE*)strm);
	}
}
