/*
	init.h
	
	(c) Richard Thrippleton, July 2001
	Licensing terms are in the 'LICENSE' file
	If that file is not included with this source then permission is not given to use this source in any way whatsoever.
*/

void initinterface(); //Initialise user interface
void initalis(); //Initialise the alliance database
void initcalc(); //Initialise central maths routines
void initequip(); //Initialises the equipment database
void initships(); //Initialises the ship database 
void initplanets(); //Initialises the planet data
void initfrags(); //Initialises all the frags in the database
void initgraphics(); //Initialises the main SDL window
void inituniverse(); //Creates a brand new universe

void control(); //User key control
void drawinterface(); //Draw the interface
void testship();
void testplanets();
void seed(); //Initialises random number generator with unique value
void update(); //Updates graphics changes to the screen
void drawplanets(); //Draws all the onscreen planets
void drawfrags(); //Draw all frags in view
void drawships(); //Goes through all ships, drawing them
void doships(); //Handle events on all ships such as physics, targetting behaviour etc.
void dofrags(); //Run physics on all frags
short shipyard(); //Trys to spawn a random ship, returns index, -1 if unable to comply
