/*
	public.h
	
	(c) Richard Thrippleton, July 2001
	Licensing terms are in the 'LICENSE' file
	If that file is not included with this source then permission is not given to use this source in any way whatsoever.
*/

struct vct //A vector
{
	long xx;
	long yy; //X and Y components
};

struct pol //A polar vector
{
	short ang; //Angle
	long rad; //Radius
};

vct poltovct(pol in,bool hres); //Converts a polar to a vector. High res mode?
pol vcttopol(vct in); //Converts a vector to a polar
long quickroot(long x); //Computes the square root of x
long rnd(long max); //Returns a random number from 0 to max

short newship(short indx,long x,long y,short all); //Creates a new ship, returning its index
void* getship(short indx); //Returns a pointer to the given ship
void radarships(long povx,long povy,long rng); //Draw ships on radar with given point of view and radar range
short retargetships(void* mine,short typ); //Toggle user's target (typ: 1 - Any  2 - Enemy)
void scanship(void* mine,short indx); //Scan and printout in the console

void* getequip(short indx); //Returns a pointer to equipment item indx

void* getplanet(short indx); //Returns planet of given index
void radarplanets(long povx,long povy,long rng,short trg); //Draw planets on radar with given point of view, radar range and target
short retargetplanets(void* mine,short typ); //Toggle user's planetary target (typ: 1 - Nearbye bodies 2 - Long range systems)
void scanplanet(void* mine,short indx); //Scans the planet onto the console
void newsystem(long x,long y,short all); //Creates a new star system at the given position with given alliance
void starchart(long povx,long povy,short trg); //Draws a starchart on the console, hilighting the ship (at pov)

bool opposes(short a,short b); //Is alliance a opposed to alliance b?
void* getali(short indx); //Return a pointer to given index of alliances
short getspawn(short indx); //Generates a ship index suitable for given alliance index, and returns it

void newfrag(void* in); //Creates a new frag
void radarfrags(long povx,long povy,long rng); //Draw frags on radar with given point of view and radar range
void purgefrags(short trg); //Purges target of all frags targetted on trg

void string(char* str,short x,short y); //Prints a string at the given co-ordinates
void drawsprite(short indx,short x,short y,short rot,short mode); //Public wrapper to draw sprite of given index

void box(long x,long y,long w,long h,short col); //Draw a box, colour given using own colour lookup table
void getspritedims(short indx,short rot,short mode,short* hw,short* hh); //Returns the hw and hh dimensions of a given sprite
void clip(short x,short y,short w,short h); //Wrapper for ClipRect
void pix(long x,long y,short col); //Draws a pixel at given co-ordinates

long extractlong(void* strm,char* attr); //Extracts the integer value of the named attribute from the given filestream
void extractstring(void* strm,char* attr,char* put); //Puts the value of attribute attr into put

void debug(const char* str,long num); //Reports a debugging string
void memtest(void* ptr); //Asserts that the given pointer isn't NULL (use for wrapping around 'new' calls)
void sdlnulltest(void* test); //Give it the pointer to an SDL surface you've just tried to make, and it will terminate the program if there's a problem

bool see(long x,long y); //Can you see the given co-ordinates?
void printcons(char* text); //Write text to the console
void spritecons(short indx); //Draws a sprite in the console of given index
void getreal(long x,long y,long* ax,long* ay); //Gives the actual screen position

void quit(char* msg); //Quit with the given message

const long LIMIT=288000000; //Bounds of the universe
