/*
	sv.cpp
	
	(c) Richard Thrippleton, July 2001
	Licensing terms are in the 'LICENSE' file
	If that file is not included with this source then permission is not given to use this source in any way whatsoever.
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <SDL.h>
#include "init.h"
#include "public.h"

extern short me;

int main(int argc,char* argv[])
{
	const Uint32 dly=40; //Delay in milliseconds to achieve 24fps
	Uint32 ntm,otm,dif; //Time values, for fps restriction in the loop
	Uint32 stm;
	long frms;
	char txt[32];
	
	frms=0;
	seed();
	initcalc();
	initequip();
	initalis();
	initships();
	initfrags();
	initplanets();
	inituniverse();
	initinterface();
	initgraphics();	
	while(shipyard()==-1)
	{
	}
	me=0;
	while(true)
	{
		if(frms%400==0)
		{
			stm=SDL_GetTicks();
			frms=0;
		}
		frms++;
		otm=SDL_GetTicks();
		doships();
		control();
		dofrags();
		drawinterface();
		drawplanets();
		drawships();
		drawfrags();
		shipyard();
		sprintf(txt,"FPS %f",(float)frms/(((float)otm-(float)stm)/1000));
		string(txt,0,0);	
		update();
		ntm=SDL_GetTicks();
		dif=(ntm-otm);
		if(dif<dly)
		{
			dif=dly-dif;
			SDL_Delay(dif);
		}
	}
}

void debug(const char* str,long num)
{
	printf("%s  %ld\n",str,num);
	fflush(NULL);
}
                
void memtest(void* ptr)
{
	if(ptr==NULL)
		quit("Error allocating dynamic memory");
}

void sdlnulltest(void* test)
{
	char* err; //Error string
	
	if(test==NULL)
	{
		memtest(err=new char[strlen(SDL_GetError())+16]);
		sprintf(err,"SDL Error: %s",SDL_GetError());
		quit(err);
	}
}
                                                                                
void quit(char* msg)
{
	SDL_Quit();
	if(msg!=NULL)
		printf("%s\n",msg);
	exit(0);
}
